Subject: Re: bug#51821: 29.0.50; Suggest add variable or frame parameter: line-height

From: "Feng Shu" <[email-masked]>
Date: Sat, 20 Nov 2021 15:13:16 +0800

Eli Zaretskii <[email-masked]> writes:

>> From: "Feng Shu" <[email-masked]>
>> Cc: Lars Ingebrigtsen <[email-masked]>,  [email-masked]
>> Date: Sat, 20 Nov 2021 07:03:18 +0800
>> 
>> yestaday, I have tested with hack version of your patch, I think
>> line-height or line-height-factor is not a proper way to solve my core
>> problem.
>> 
>>    My core problem is how to let tab/mode/header-line and minibuffer's
>>    height do not change depend Chinese exist or not.
>
> That's a different problem from that Lars wanted to solve, AFAIU.

Really? wait to good news :-)

>
>> line-height-factor can let their height do not change, but the problem
>> is that the result looks very ugly, for line-space very large, It will
>> be painful in daily use.
>
> I agree it is not very pretty, but I don't see how such a feature
> could do much better.

:-)

>
>> so I think the good approach maybe is providing a simple way, by which
>> we can easy let no-ascii font use small height if a face is not used in
>> table like environment.
>
> That's no longer a display issue, I think.  And I don't really
> understand how we could implement that, since faces are oblivious to
> the context in which they are used.

I do not know too, just a guess :-),  let face use a fontset? I do not know.

>
> And what do you mean by "table like environment"? do you mean
> tabulated-list-mode and its descendants, or do you mean Org tables, or

yes, include

> do you mean just simple text display that emulates tables by aligning
> text on column boundaries, like, for example, in Gnus summary buffers?

yes, include

>
> And finally, what do you mean by "no-ascii font use small height" --
> how will Emacs ensure such smaller height of these fonts?
>
>> In my opinion "1 Chinese char width = 2 * ASCII char width" is *only*
>> useful in table like environment. let Chinese char's height <= ASCII
>> char's height will work well in other situation, and have no
>> tab/mode/header-line height change problem too.
>
> Until now, your main concern was that the echo-area height changes
> depending on whether it does or doesn't show Chinese characters.  Are

Yes, it is my main concern.

> you now saying that concern is no longer important?  If so, why do we

No, I mean if Chinese font's height <= ASCII font height, it will no
this problem, so I think line height will no longer important at this
situation.

> need to do anything about the height of the Chinese font used by Emacs
> in text that mixes Chinese and ASCII characters?

--